<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Exploration - Testing</title>
    <link type="text/css" rel="stylesheet" href="/explorer/local.css">
    <link type="text/css" rel="stylesheet" href="../Resources/css/global.css">
</head>
<body>



<script type="module">
    import * as d3 from "https://cdn.jsdelivr.net/npm/d3@7/+esm";
    import {GroundTruths} from "/explorer/groundtruths.js";
    import {FoundPatterns} from "/explorer/foundpatterns.js";
    import * as Patterns from "/explorer/patterns.js";
    import {GlyphCharter} from "/explorer/glyphCharter.js";
    import {Histogrammer} from "/explorer/Histogrammer.js";
    import {Legender} from "/explorer/legend.js";
    import {LineGrapher} from "/explorer/linegrapher.js";

    //Current color scheme
    const FOUNDPATTERNCOLOR = "#7fc97f";
    const GROUNDTRUTHCOLOR = "#beaed4";
    const TIMESERIESCOLOR = "#FFE6AB";

    //Import files
    let groundTruthFile = await d3.json("/explorer/files/groundtruths.json");
    let foundPatternFile = await d3.json("/explorer/files/Method1.json");
    let timeSeries = await d3.csv("/explorer/files/timeseries.csv");
    let multiTrackSeries = await d3.csv("/explorer/files/multitrackseries.csv", d =>{
        return {
            time: +d.Time,
            track1: +d.Track1,
            track2: +d.Track2,
            track3: +d.Track3,
            track4: +d.Track4,
            track5: +d.Track5,
            track6: +d.Track6,
            track7: +d.Track7,
            track8: +d.Track8,
            track9: +d.Track9,
            track10: +d.Track10,
            track11: +d.Track11,
            track12: +d.Track12,
            track13: +d.Track13,
            track14: +d.Track14
        }
    });

    //Values determined to make proper scaling for multitrack
    let timeMin = d3.min(multiTrackSeries, d => {return d.time});
    let timeMax = d3.max(multiTrackSeries, d => {return d.time});
    let seriesLength = multiTrackSeries.length;

    //This scale is used when real data is used, configured to translate to smaller timesteps than 1
    let timeSeriesScale = d3.scaleLinear()
        .domain([0, seriesLength])
        .range([timeMin, timeMax]);

    //Instantiate groundTruth array class and foudnPattern array class
    let groundTruths = new GroundTruths();
    let foundPatterns = new FoundPatterns();

    groundTruthFile.forEach((truth) =>{
        groundTruths.push(new Patterns.GroundTruth(truth.start, truth.ending, GROUNDTRUTHCOLOR));
    })

    foundPatternFile.forEach((pattern) =>{
        foundPatterns.push(new Patterns.FoundPattern(pattern.start, pattern.ending, pattern.confidence, FOUNDPATTERNCOLOR));
    })


    //Setup svg for glyphchart
    const glyphChartMargin = {top: 0, right: 30, bottom: 30, left: 5},
        glyphChartWidth = 600 - glyphChartMargin.left - glyphChartMargin.right,
        glyphChartHeight = 500 - glyphChartMargin.top - glyphChartMargin.bottom;

    const glyphChartSvg = d3.select("#glyphChartTarget").append("svg")
        .attr("width", glyphChartWidth + glyphChartMargin.left + glyphChartMargin.right)
        .attr("height", glyphChartHeight + glyphChartMargin.top + glyphChartMargin.bottom)
        .append("g")
        .attr("transform", "translate(" + glyphChartMargin.left + "," + glyphChartMargin.top + ")");

    const legendMargin = {top: 30, right: 30, bottom: 0, left: 5},
        legendWidth = 600 - legendMargin.left - legendMargin.right,
        legendHeight = 150 - legendMargin.top - legendMargin.bottom;

    const legendSvg = d3.select("#legendTarget").append("svg")
        .attr("width", legendWidth + legendMargin.left + legendMargin.right)
        .attr("height", legendHeight + legendMargin.top + legendMargin.bottom)
        .append("g")
        .attr("transform", "translate(" + legendMargin.left + "," + legendMargin.top + ")");

    let glyphCharter = new GlyphCharter(glyphChartSvg, glyphChartWidth, glyphChartHeight, groundTruths,
    foundPatterns, timeSeries, 0.1);

    let legender = new Legender(legendSvg, legendWidth, legendHeight, FOUNDPATTERNCOLOR, TIMESERIESCOLOR, GROUNDTRUTHCOLOR);

    const histoMargin = {top: 10, right: 50, bottom: 30, left: 7},
        histowidth = 500 - histoMargin.left - histoMargin.right,
        histoheight = 400 - histoMargin.top - histoMargin.bottom;
    let histoSvg = d3.select("#histoTarget").append("svg")
        .attr("width", histowidth + histoMargin.left + histoMargin.right)
        .attr("height", histoheight + histoMargin.top + histoMargin.bottom)
        .append("g")
        .attr("transform", "translate(" + histoMargin.left +  "," + histoMargin.top + ")");
    let histoGrammer = new Histogrammer(histoSvg, histoheight, histowidth, foundPatterns, groundTruths);

    let lineGraphMargin = {top: 10, right: 50, bottom: 30, left: 7},
        lineGraphWidth = 800 - lineGraphMargin.left - lineGraphMargin.right,
        lineGraphHeight = 400 - lineGraphMargin.top - lineGraphMargin.bottom;
    let lineGraphSvg = d3.select("#lineGraphTarget").append("svg")
        .attr("width", lineGraphWidth + lineGraphMargin.left + lineGraphMargin.right)
        .attr("height", lineGraphHeight + lineGraphMargin.top + lineGraphMargin.bottom)
        .append("g")
        .attr("transform", "translate(" + lineGraphMargin.left + "," + lineGraphMargin.top + ")");
    let lineGrapher = new LineGrapher(lineGraphSvg, lineGraphHeight, lineGraphWidth, timeSeries, groundTruths, foundPatterns, TIMESERIESCOLOR, GROUNDTRUTHCOLOR, FOUNDPATTERNCOLOR);

    d3.select("#sortingselect").on("change", function(){
        let newSorting = d3.select(this).property("value");
        glyphCharter.updateSorting(newSorting);
    })

    //Declare functionality for selecting confidence cutoff in histogram
    histoSvg.style("pointer-events", "bounding-box").on("mousemove", (event,d) => {
        let realX = event.offsetX - histoMargin.left;
        if ((realX <= histowidth) && (realX >= 0)){
            histoGrammer.hoverline.attr("x1", realX).attr("x2", realX);
            histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
        } else if (realX > histowidth){
            histoGrammer.hoverline.attr("x1", histowidth).attr("x2", histowidth);
            histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
        } else if (realX < 0){
            histoGrammer.hoverline.attr("x1", 0).attr("x2", 0);
            histoGrammer.newCutoffText.text("Selected: " + (Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
        }
    }).on("click", (event,d) =>{
        let realX = event.offsetX - histoMargin.left;
        if ((realX <= histowidth) && (realX >= 0)){
            histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
            histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
            glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(realX) * 100) / 100).toFixed(2));
        } else if (realX > histowidth){
            histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
            histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
            glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(histowidth) * 100) / 100).toFixed(2));
        } else if (realX < 0){
            histoGrammer.currentSelectionLine.transition().duration(100).attr("x1", realX).attr("x2", realX);
            histoGrammer.currentCutoffText.text("Current cutoff: " + (Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
            glyphCharter.setConfidenceCutoff((Math.round(histoGrammer.xScale.invert(0) * 100) / 100).toFixed(2));
        }
    })



    let cardMargin = 20;
    let cardPadding = 15;
    let cardWidth = (glyphChartWidth + glyphChartMargin.left + glyphChartMargin.right) + 2 * cardMargin;
    d3.select("#glyphCard")
        .style("width", cardWidth + "px")
        .style("margin", cardMargin + "px")
        .style("padding", cardPadding + "px");

    d3.select("#toggleShadowLineSwitch")
        .on("change", d =>{glyphCharter.toggleShadowLines()});

    d3.select("#vizTechSelect")
        .on("change", function(d){
            lineGrapher.setNewVizTechnique(d3.select(this).property("value"));
    })

</script>

<nav class="navbar is-primary" role="navigation" aria-label="main navigation">
    <div class="navbar-brand">
        <h1 class="title is-2" style="margin-left: 60px">
            "Aligned" Glyph Chart
        </h1>
    </div>
</nav>

<div class="content">
    <div class="columns">
        <div class="card" id="glyphCard">
            <div class="is-flex">
                <div id="toggleShadowLineContainer">
                    <input id="toggleShadowLineSwitch" type="checkbox" name="toggleShadowLineSwitch"
                           class="switch is-rounded" checked="checked">
                    <label for="toggleShadowLineSwitch">Show Shadow Patterns</label>
                </div>
                <div class="select is-small mt-2 ml-auto is-rounded">
                    <select id="sortingselect">
                        <option name="occasc" value="chronAsc" selected="selected">Chronological, ascending</option>
                        <option name="occdes" value="chronDesc">Chronological, descending</option>
                        <option name="confasc" value="confAsc">Confidence, ascending</option>
                        <option name="confdes" value="confDesc">Confidence, descending</option>
                    </select>
                </div>
            </div>
            <table id="glyphtable" class="table">
                <thead>
                <tr>
                    <th>
                        Glyph
                    </th>
                    <th style="text-align: right">
                        Confidence
                    </th>
                </tr>
                </thead>
            </table>
            <div id="glyphChartTarget">
            </div>
            <nav class="pagination is-rounded is-centered" role="navigation" aria-label="pagination">
                <a href="#" class="pagination-previous" id="paginationPrevious">Previous</a>
                <a href="#" class="pagination-next" id="paginationNext">Next Page</a>
                <ul class="pagination-list mt-0 ml-0" id="paginationTarget">
                </ul>
            </nav>
            <div class="box">
                <p class="subtitle is-5 mb-0">Legend.</p>
                <div id="legendTarget"></div>
            </div>
        </div>
        <div class="column">
            <div class="ml-5 mt-5">
                <p class="subtitle is-5 mb-0">Confidence distribution</p>
                <p class="subtitle is-6 mb-2">Use this histogram to select the confidence cutoff</p>
            </div>
            <div class="ml-5">
                <div id="histoTarget">
                </div>
            </div>
            <div class="ml-5 mt-5">
                <p class="subtitle is-5 mb-0 is-inline-block">Time Series</p>
                <div class="select is-small ml-6 is-inline-block is-rounded">
                    <select id="vizTechSelect">
                        <option name="DashedLines" value="DashedLines" selected="selected">DashedLines</option>
                        <option name="BoundedBox" value="BoundedBox">BoundedBox</option>
                        <option name="OpacityDelta" value="OpacityDelta">OpacityDelta</option>
                    </select>
                </div>
            </div>
            <div class="ml-5">
                <div id="lineGraphTarget">
                </div>
            </div>
        </div>
    </div>
    <p>

    </p>
</div>

<svg  height="0" width="0" xmlns="http://www.w3.org/2000/svg" version="1.1">
    <defs>
        <pattern id="diagonalHatch" patternUnits="userSpaceOnUse" width="8" height="8">
            <rect width="8" height="8" fill="#beaed4"></rect>
            <path d="M-1,1 l2,-2
                        M0,8 l8,-8
                        M7,9 l2,-2"
                  style="stroke:#7fc97f; stroke-width:2.5;"/>
        </pattern>
    </defs>
</svg>

</body>
</html>